unit libnotyf;

{$mode ObjFPC}
{$modeswitch externalclass}

interface

uses
  JS;

Type
  TJSNotyfPosition = class external name 'Object' (TJSObject)
    x,y : string;
  end;

  TJSNotyfIcon  = class external name 'Object' (TJSObject)
    className : string;
    tagName : string;
    text : string;
    color : string;
  end;

  TJSNotyfNotificationOptions = class external name 'Object' (TJSObject)
    type_ : string; external name 'type';
    className : string;
    duration : Integer;
    icon : TJSNotyfIcon;
    iconBoolean : boolean; external name 'icon';
    background : string;
    message : string;
    dismissable : boolean;
  end;

  TJSNotyfOptions = class external name 'Object' (TJSObject)
    duration : Integer;
    position : TJSNotyfPosition;
    ripple : boolean;
    dismissable : boolean;
    types : array of TJSNotyfNotificationOptions;
  end;

  TJSNotyfNotification = class external name 'NotyfNotification' (TJSObject);

  TJSNotyf = class external name 'Notyf' (TJSObject)
    constructor new (aOptions : TJSNotyfOptions); overload;
    constructor new (aOptions : TJSObject); overload;
    procedure dismiss(aNotification :TJSNotyfNotification);
    procedure dismissAll;
    function success(aMessage : String) : TJSNotyfNotification;
    function success(aSettings : TJSObject) : TJSNotyfNotification;
    function error(aMessage : String) : TJSNotyfNotification;
    function error(aSettings : TJSObject) : TJSNotyfNotification;
    function open(aSettings : TJSObject) : TJSNotyfNotification;
  end;

implementation

end.

