program trayicon;

{$mode objfpc}
{$modeswitch externalclass}

uses
  JS, SysUtils, Web, libnotyf;

Type
  TClickHandler = reference to procedure (aID : Integer);

  TTrayIcon = class external name 'Object' (TJSObject)
    visible : boolean;
    function addMenuItem(aCaption :string; aHandler : TClickHandler) : integer;
    procedure removeMenuItem(aID: Integer);
  end;

Var
  aCount : Integer;
  opts : TJSNotyfOptions;
  notyf : TJSNotyf;
  trayIcon : TTrayIcon; external name 'window.trayIcon';

procedure DoLog(Msg : string);

begin
  console.log(msg);
  notyf.success(msg);
end;

procedure trayIconClicked(aID : integer);
begin
  aCount:=aCount+1;
  doLog('Menu item '+IntToStr(aID)+' Clicked!');
  TJSHTMLElement(Document.getElementById('count')).innerText:=IntToStr(aCount);
  TJSHTMLElement(document.getElementById('lastid')).innerText:=IntToStr(aID);
end;

procedure DoAddMenuItem(aEvent : TJSEvent);

Var
  aCaption : String;
  aID : Integer;

begin
  aCaption:=TJSHTMLInputElement(document.getElementById('myCaption')).value;
  aID:=trayIcon.addMenuItem(aCaption,@trayIconClicked);
  DoLog('Menu item with ID '+IntToStr(aID)+' Created!');
end;

procedure DoRemoveMenuItem(aEvent : TJSEvent);

var
  aID : Integer;

begin
  aID:=StrToIntDef(TJSHTMLInputElement(document.getElementById('myRemoveId')).value,-1);
  if aID<>-1 then
    trayIcon.removeMenuItem(aID);
  DoLog('Menu item with ID '+IntToStr(aID)+' removed!');
end;

Procedure DoVisibleClick(aEvent: TJSEvent);
begin
  trayIcon.visible:=true;
  doLog('TrayIcon: '+BoolToStr(trayIcon.visible));
end;

Procedure DoInVisibleClick(aEvent: TJSEvent);
begin
  trayIcon.visible:=false;
  doLog('TrayIcon: '+BoolToStr(trayIcon.visible));
end;

Procedure AddClick(aName: string; aHandler : TJSRawEventHandler);

Var
  El : TJSHTMLElement;

begin
  El:=TJSHTMLElement(document.getElementById(aName));
  el.AddEventListener('click',aHandler);
end;

begin
  opts:=TJSNotyfOptions.new;
  opts.position:=TJSNotyfPosition.New;
  opts.position.x:='center';
  opts.position.y:='top';
  notyf:=TJSNotyf.new(opts);
  AddClick('btnVisible',@DoVisibleClick);
  AddClick('btnInvisible',@DoInVisibleClick);
  AddClick('btnAddMenuItem',@DoAddMenuItem);
  AddClick('btnRemoveMenuItem',@DoRemoveMenuItem);
end.
